#include <stdio.h>
#include <string.h>

int bintohex(int argc, char **argv)
{
	int i;
	unsigned char c;
	char inf[64], of[64];
	FILE *infile, *outfile;
	
	strcpy(inf, argv[1]);
	strcpy(of, argv[1]);
	
	strcat(inf, ".bin");
	strcat(of, ".hex");
	
	if (argc != 2)
	{
		fprintf(stderr, "bintohex: Usage: bintohex <filename> (without .bin)\n");
		return(1);
	}
	if (!(infile = fopen(inf,"rb")))
	{
		fprintf(stderr, "bintohex: Can't open input file.\n");
		return(2);
	}
	if (!(outfile = fopen(of, "wb")))
	{
		fprintf(stderr, "bintohex: Can't open output file.\n");
		return(3);
	}

	for (i = 0; (c = fgetc(infile)) != (unsigned char) EOF; i++);

	rewind(infile);

	fprintf(outfile, ":%02X%02X0000", i%256, i/256);
	
	while ((c = fgetc(infile)) != (unsigned char) EOF)
		fprintf(outfile, "%02X", c);

	//fputc('\n', outfile);

	fclose(infile);
	fclose(outfile);

	return(0);
}
