#ifdef PACKAGE_NAME	// Defining Program Name.

#define PROGNAME PACKAGE_NAME

#else

#define PROGNAME "bzc"

#endif



#ifndef OUTPUT_DEVICE

#define OUTPUT_DEVICE "out.asm"

#endif



#ifndef INPUT_DEVICE

#define INPUT_DEVICE "Standart Input"

#endif



#if (ENABLE_MEM_DEBUG == 1)

#define MEM_DEBUG

#endif



#if (ENABLE_VERBOSE == 1)

#define CMD_DEBUG	// All messages (only for developers)

#elif (ENABLE_VERBOSE == 2)

#define ANAL_DEBUG	// Keyword analyse messages

#elif (ENABLE_VERBOSE == 3)

#define DEV_DEBUG	// Just being *very* verbose

#endif



#ifdef MEM_DEBUG

#ifndef MEMLINE_DEBUG

#define MEMLINE_DEBUG

#endif

#ifndef TABLE_DEBUG

#define TABLE_DEBUG

#endif

#endif



#ifdef DEV_DEBUG	

#ifndef ANAL_DEBUG

#define ANAL_DEBUG

#endif

#endif



#ifdef ANAL_DEBUG	



#ifndef CMD_DEBUG	// We also want to know at which line we are...

#define CMD_DEBUG

#endif



#ifndef NEW_DEBUG	// NEW keyword.

#define NEW_DEBUG

#endif



#ifndef CODE_DEBUG	// CODE keyword

#define CODE_DEBUG

#endif



#ifndef START_DEBUG	// START keyword

#define START_DEBUG

#endif



#ifndef FUNC_DEBUG	// Not known keyword is a function

#define FUNC_DEBUG

#endif



#ifndef VAR_DEBUG	// Not known keyword is a variable

#define VAR_DEBUG

#endif



#endif



#ifdef NEW_DEBUG



#ifndef REG_DEBUG	// NEW REG keyword

#define REG_DEBUG

#endif



#ifndef ROMCALL_DEBUG	// NEW ROMCALL kewyword

#define ROMCALL_DEBUG

#endif



#ifndef NEW_FUNC_DEBUG	// NEW FUNCTION keyword

#define NEW_FUNC_DEBUG

#endif



#ifndef NEW_VAR_DEBUG	// NEW VAR keyword

#define NEW_VAR_DEBUG

#endif



#ifndef SPRITE_DEBUG

#define SPRITE_DEBUG

#endif



#endif



#ifdef DECL_VARS

#define EXTERN

#else

#define EXTERN extern

#endif



#ifdef DUMP_MEM_ON_ERRORS

#ifndef MEMORY_DUMP_ON_EXIT_FAILURE

#define MEMORY_DUMP_ON_EXIT_FAILURE

#endif

#endif



#ifndef UNIX

#ifndef WINDOWS

#ifdef HAVE_CONFIG_H

#define UNIX

#else

#define WINDOWS

#endif

#endif

#endif

